/*----- PROTECTED REGION ID(PduMapper.h) ENABLED START -----*/
//=============================================================================
//
// file :        PduMapper.h
//
// description : Include file for the PduMapper class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessandro.olivo $
//
// $Revision: 1.1.1.1 $
// $Date: 2017-10-02 14:01:30 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PduMapper_H
#define PduMapper_H

#include <tango.h>
#include "PduMap.h"

/*----- PROTECTED REGION END -----*/	//	PduMapper.h

/**
 *  PduMapper class description:
 *    
 */

namespace PduMapper_ns
{
/*----- PROTECTED REGION ID(PduMapper::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

class AttributeChangeCallBack;

/*----- PROTECTED REGION END -----*/	//	PduMapper::Additional Class Declarations

class PduMapper : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(PduMapper::Data Members) ENABLED START -----*/

//	Add your own data members
public:

	Tango::DeviceProxy *dbTangoProxy;
	AttributeChangeCallBack *attrChngCllBck;
	PduMap* pdu_map;
	string unmapped_pdu_ls;
	size_t tangodb_pdu_count;
	
/*----- PROTECTED REGION END -----*/	//	PduMapper::Data Members

//	Device property data members
public:
	//	pduListPattern:	Pattern that allows creation of the list of pdu, e.g. ``*/pdu/*``
	string	pduListPattern;

	bool	mandatoryNotDefined;


//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	PduMapper(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	PduMapper(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	PduMapper(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~PduMapper() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : PduMapper::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);


	//--------------------------------------------------------
	/**
	 *	Method      : PduMapper::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
	 *
	 *	@returns Device state
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command Status related method
	 *	Description: This command gets the device status (stored in its device_status data member) and returns it to the caller.
	 *
	 *	@returns Device status
	 */
	virtual Tango::ConstDevString dev_status();
	/**
	 *	Command GetPduListFromNamePattern related method
	 *	Description: 
	 *
	 *	@param argin Regex pattern, that indentify part of the Tango name of a pdu (es. uh/pdu/.* )
	 *	@returns List of Tango pdu names matched (could return one or zero pdu name)
	 */
	virtual Tango::DevVarStringArray *get_pdu_list_from_name_pattern(Tango::DevString argin);
	virtual bool is_GetPduListFromNamePattern_allowed(const CORBA::Any &any);
	/**
	 *	Command GetPduListFromOutletPattern related method
	 *	Description: 
	 *
	 *	@param argin Regex pattern, that is part of an outlet name (es. .*MSCR.* )
	 *	@returns Tango name list of the pdu whose outlets match the passed argument (could return one or zero pdu name)
	 */
	virtual Tango::DevVarStringArray *get_pdu_list_from_outlet_pattern(Tango::DevString argin);
	virtual bool is_GetPduListFromOutletPattern_allowed(const CORBA::Any &any);
	/**
	 *	Command GetPduInfoFromName related method
	 *	Description: 
	 *
	 *	@param argin PDU Tango name : ``domain/family/member``
	 *	@returns List formatted with Name and State value of the pdu like that:
	 *           [``Name01``,``State01``,``Name02``,``State02``,...]
	 */
	virtual Tango::DevVarStringArray *get_pdu_info_from_name(Tango::DevString argin);
	virtual bool is_GetPduInfoFromName_allowed(const CORBA::Any &any);
	/**
	 *	Command GetOutletsListFromOutletPattern related method
	 *	Description: 
	 *
	 *	@param argin Regex pattern, that is part of an outlet name (es. .*MSCR.* )
	 *	@returns List of all outlets names matched
	 */
	virtual Tango::DevVarStringArray *get_outlets_list_from_outlet_pattern(Tango::DevString argin);
	virtual bool is_GetOutletsListFromOutletPattern_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : PduMapper::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(PduMapper::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
 void createPduList(vector<string>&);
 void addPduData(string dev_name);

/*----- PROTECTED REGION END -----*/	//	PduMapper::Additional Method prototypes
};

/*----- PROTECTED REGION ID(PduMapper::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

class AttributeChangeCallBack : public Tango::CallBack
{
	void push_event(Tango::EventData *ev);
};


/*----- PROTECTED REGION END -----*/	//	PduMapper::Additional Classes Definitions

}	//	End of namespace

#endif   //	PduMapper_H
